
/******************************************************************************
*       Copyright (C) 2005 Freescale Semiconductor, Inc.
*       All Rights Reserved
*
* Filename:     DEMO9S08QD4_Test.c
* Author:       r1aald
* Revision:     1.0
*
* Description:  This is the test code that will reside in the QD4 demo board
*                to provide an out of the box experience. This simple code
*                blinks LED1 automatically when SW2 is pressed
*                and toggles LED1 when SW1 is pressed.
*
* Notes:        Also serves as an example for the 9S08QD4 demo board.
*               Created using CodeWarrior 5.0 for HC(S)08.
******************************************************************************/


#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */
#include "demo9S08QD4.h" /*include demo board declarations */


#define BKGD_DISABLED
	 

void main(void) {
  
  EnableInterrupts; /* enable interrupts */
  
  #ifdef BKGD_DISABLED
  SOPT1_BKGDPE = 0;
  #endif
  
  ICSC2_BDIV = 3;   //Set bus divide to divide by 8
  
  LED1 =0;
  LED1_DDR = 1;
  

 
  
  /** KBI Set Up foe SW1 & SW2 */
  KBIPE_KBIPE2 =1; /* Enable Keyboard Pin */                                  
  KBIPE_KBIPE3 =1; /* Enable Keyboard Pin */                                  

  
  KBISC_KBIE =  1;  /* Enable Keyboard Interrupts */
  KBISC_KBACK = 1;  /* Clear Pending Keyboard Interrupts */
  
  PTAPE_PTAPE2 = 1; /* Enable Pullup for Keyboard pin */
  PTAPE_PTAPE3 = 1; /* Enable Pullup for Keyboard pin */
   
   
   
    /** timer_setup */
  TPMMOD = 0x2000;
  TPMSC_PS = 0x07; //Set Div 128 prescaler
  TPMSC_TOIE = 1;  //Enable Timer Overflow Interrupt
  TPMSC_CLKSx = 1; //Select Bus clock and start the timer           
  
  for(;;) {
    __RESET_WATCHDOG(); /* feeds the dog */
    
    
  } /* loop forever */
}  /* please make sure that you never leave this function */



/** KBI ISR */
interrupt 18 void   KBI_ISR(void) {  
//Check wich SW was pressed


  if (!SW1){
  
  
   TPMSC_CLKSx = 0x00;   //Stop and reset the timer  
   LED1 = ~LED1;    /* toggle Port */ 
  
  
  }else if (!SW2){
  
   TPMSC_CLKSx = 0x01; //Start the timer
  
  }
  
  KBISC_KBACK = 1; /* Clear Pending Keyboard Interrupts */
}


/** TIM1OVFL_ISR - ISR that provides the timebase. */
interrupt 7 void   TIM1OVFL_ISR(void) {
      /* clear TOF */
     
      LED1 = ~LED1;    /* toggle Port */ 
      TPMSC_TOF = 0;
      
      
  
}

